"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseReadsController = void 0;
const common_1 = require("@nestjs/common");
const dto_1 = require("./dto");
const reads_service_1 = require("./reads.service");
let BaseReadsController = class BaseReadsController {
    constructor(readsService) {
        this.readsService = readsService;
    }
    async getReads(meterId, filter) {
        const res = await this.readsService.find(meterId, filter);
        return res;
    }
    async getReadsDifference(meterId, filter) {
        const res = await this.readsService.findDifference(meterId, filter);
        return res;
    }
    async getReadsAggregates(meterId, filter) {
        const res = await this.readsService.aggregate(meterId, filter);
        return res;
    }
    async getLatestRead(meterId, filter) {
        const res = await this.readsService.findLatestRead(meterId, filter === null || filter === void 0 ? void 0 : filter.start);
        return res;
    }
    async storeReads(meterId, measurement) {
        await this.readsService.store(meterId, measurement);
    }
};
__decorate([
    (0, common_1.Get)('/:meter'),
    __param(0, (0, common_1.Param)('meter')),
    __param(1, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, dto_1.FilterDTO]),
    __metadata("design:returntype", Promise)
], BaseReadsController.prototype, "getReads", null);
__decorate([
    (0, common_1.Get)('/:meter/difference'),
    __param(0, (0, common_1.Param)('meter')),
    __param(1, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, dto_1.FilterDTO]),
    __metadata("design:returntype", Promise)
], BaseReadsController.prototype, "getReadsDifference", null);
__decorate([
    (0, common_1.Get)('/:meter/aggregate'),
    __param(0, (0, common_1.Param)('meter')),
    __param(1, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, dto_1.AggregateFilterDTO]),
    __metadata("design:returntype", Promise)
], BaseReadsController.prototype, "getReadsAggregates", null);
__decorate([
    (0, common_1.Get)('/:meter/latest'),
    __param(0, (0, common_1.Param)('meter')),
    __param(1, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, dto_1.StartPeriodDTO]),
    __metadata("design:returntype", Promise)
], BaseReadsController.prototype, "getLatestRead", null);
__decorate([
    (0, common_1.Post)('/:meter'),
    __param(0, (0, common_1.Param)('meter')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, dto_1.MeasurementDTO]),
    __metadata("design:returntype", Promise)
], BaseReadsController.prototype, "storeReads", null);
BaseReadsController = __decorate([
    (0, common_1.UseInterceptors)(common_1.ClassSerializerInterceptor),
    (0, common_1.UsePipes)(new common_1.ValidationPipe({ transform: true })),
    (0, common_1.Controller)(),
    __metadata("design:paramtypes", [reads_service_1.ReadsService])
], BaseReadsController);
exports.BaseReadsController = BaseReadsController;
//# sourceMappingURL=base-reads.controller.js.map