import { OnModuleInit } from '@nestjs/common';
import { AggregatedReadDTO, AggregateFilterDTO, FilterDTO, MeasurementDTO, ReadDTO } from './dto';
import { ConfigService } from '@nestjs/config';
import { AllowedDurationType } from './allowed-duration.type';
export declare class ReadsService implements OnModuleInit {
    private readonly configService;
    private readonly logger;
    private bucket;
    private organization;
    private config;
    constructor(configService: ConfigService);
    onModuleInit(): Promise<void>;
    store(meterId: string, measurement: MeasurementDTO): Promise<void>;
    aggregate(meterId: string, filter: AggregateFilterDTO): Promise<AggregatedReadDTO[]>;
    find(meterId: string, filter: FilterDTO): Promise<ReadDTO[]>;
    findLatestRead(meterId: string, startDuration?: AllowedDurationType): Promise<ReadDTO>;
    findDifference(meterId: string, filter: FilterDTO): Promise<ReadDTO[]>;
    private findByMeterQuery;
    private getRangeFilter;
    findLatestReadByMeterQuery(meterId: string, startDuration?: AllowedDurationType): string;
    private execute;
    private executeAggregated;
    private get dbWriter();
    private get dbReader();
    private getMultiplier;
}
